
/*
 
 iPod Control version 1.0.0
 2009/02/22
 
 */

/*
 iPodControl.c - Library for iPod Serial Control code.
 Copyright (c) recotana(http://recotana.com).  All right reserved.
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License version 2.1 as published by the Free Software Foundation.
 */



#include "ipodcontrol.h"



const byte simpleCmdData[22][7]={
{0x03,0x02,0x00,0x00,0x00,0x00,0x00},	//btton release
{0x03,0x02,0x00,0x01,0x00,0x00,0x00},	//play / pause
{0x03,0x02,0x00,0x02,0x00,0x00,0x00},	//vol +
{0x03,0x02,0x00,0x04,0x00,0x00,0x00},	//vol -
{0x03,0x02,0x00,0x08,0x00,0x00,0x00},	//skip next
{0x03,0x02,0x00,0x10,0x00,0x00,0x00},	//skip prev
{0x03,0x02,0x00,0x20,0x00,0x00,0x00},	//next album
{0x03,0x02,0x00,0x40,0x00,0x00,0x00},	//prev album
{0x03,0x02,0x00,0x80,0x00,0x00,0x00},	//stop

{0x04,0x02,0x00,0x00,0x01,0x00,0x00},	//play (only play)
{0x04,0x02,0x00,0x00,0x02,0x00,0x00},	//pause (only pause)
{0x04,0x02,0x00,0x00,0x04,0x00,0x00},	//mute
{0x04,0x02,0x00,0x00,0x20,0x00,0x00},	//next playlist
{0x04,0x02,0x00,0x00,0x40,0x00,0x00},	//prev playlist
{0x04,0x02,0x00,0x00,0x80,0x00,0x00},	//toggle shuffle

{0x05,0x02,0x00,0x00,0x00,0x01,0x00},	//toggle repeat
{0x05,0x02,0x00,0x00,0x00,0x04,0x00},	//iPod power off
{0x05,0x02,0x00,0x00,0x00,0x08,0x00},	//iPod power on
{0x05,0x02,0x00,0x00,0x00,0x40,0x00},	//menu button
{0x05,0x02,0x00,0x00,0x00,0x80,0x00},	//OK/select button

{0x06,0x02,0x00,0x00,0x00,0x00,0x01},	//scroll up
{0x06,0x02,0x00,0x00,0x00,0x00,0x02}	//scroll down
};

//mode change
//{0x03,0x00,0x01,0x02,0x00,0x00,0x00},	//Simple iPod Remote
//{0x03,0x00,0x01,0x04,0x00,0x00,0x00}	//Advanced iPod Remote 


IPodControl::IPodControl()
{

	Serial.begin(19200);

}



//Simple iPod Remote Command



void IPodControl::sirCommand(byte cmd){

	sirSend(cmd);
	sirSend(SMP_BT_RELEASE);

}

//Simple iPod Remote Command sending
void IPodControl::sirSend(byte cmd){		
	
	byte length;
	byte i;
	int sum=0;
	byte sumData;
	
	length=simpleCmdData[cmd][0];
	
	Serial.print(0xff, BYTE);
	Serial.print(0x55, BYTE);
	
	for(i=0 ; i<=length ;i++){
		
		Serial.print(simpleCmdData[cmd][i], BYTE);
		sum+=(int)simpleCmdData[cmd][i];
	}
	sumData=(byte)((0x100-sum)&0xff);
	Serial.print(sumData, BYTE);

}

